<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Storniere ServiceType
 * @subpackage Services
 */
class Storniere extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named storniereBuchung
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\StorniereBuchungAnfrage $storniereBuchungAnfrage
     * @return \StructType\StorniereBuchungErgebnis|bool
     */
    public function storniereBuchung(\StructType\StorniereBuchungAnfrage $storniereBuchungAnfrage)
    {
        try {
            $this->setResult($this->getSoapClient()->storniereBuchung($storniereBuchungAnfrage));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\StorniereBuchungErgebnis
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
