<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BerechneEntfernungAnfrage StructType
 * @subpackage Structs
 */
class BerechneEntfernungAnfrage extends Anfrage
{
    /**
     * The bahnhofsnrStart
     * Meta information extracted from the WSDL
     * - base: xs:int
     * - maxInclusive: 9999999
     * - minInclusive: 1000000
     * - nillable: false
     * @var int
     */
    public $bahnhofsnrStart;
    /**
     * The bahnhofsnrZiel
     * Meta information extracted from the WSDL
     * - base: xs:int
     * - maxInclusive: 9999999
     * - minInclusive: 1000000
     * - nillable: false
     * @var int
     */
    public $bahnhofsnrZiel;
    /**
     * Constructor method for BerechneEntfernungAnfrage
     * @uses BerechneEntfernungAnfrage::setBahnhofsnrStart()
     * @uses BerechneEntfernungAnfrage::setBahnhofsnrZiel()
     * @param int $bahnhofsnrStart
     * @param int $bahnhofsnrZiel
     */
    public function __construct($bahnhofsnrStart = null, $bahnhofsnrZiel = null)
    {
        $this
            ->setBahnhofsnrStart($bahnhofsnrStart)
            ->setBahnhofsnrZiel($bahnhofsnrZiel);
    }
    /**
     * Get bahnhofsnrStart value
     * @return int|null
     */
    public function getBahnhofsnrStart()
    {
        return $this->bahnhofsnrStart;
    }
    /**
     * Set bahnhofsnrStart value
     * @param int $bahnhofsnrStart
     * @return \StructType\BerechneEntfernungAnfrage
     */
    public function setBahnhofsnrStart($bahnhofsnrStart = null)
    {
        // validation for constraint: int
        if (!is_null($bahnhofsnrStart) && !(is_int($bahnhofsnrStart) || ctype_digit($bahnhofsnrStart))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bahnhofsnrStart, true), gettype($bahnhofsnrStart)), __LINE__);
        }
        // validation for constraint: maxInclusive(9999999)
        if (!is_null($bahnhofsnrStart) && $bahnhofsnrStart > 9999999) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically less than or equal to 9999999', var_export($bahnhofsnrStart, true)), __LINE__);
        }
        // validation for constraint: minInclusive(1000000)
        if (!is_null($bahnhofsnrStart) && $bahnhofsnrStart < 1000000) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically greater than or equal to 1000000', var_export($bahnhofsnrStart, true)), __LINE__);
        }
        $this->bahnhofsnrStart = $bahnhofsnrStart;
        return $this;
    }
    /**
     * Get bahnhofsnrZiel value
     * @return int|null
     */
    public function getBahnhofsnrZiel()
    {
        return $this->bahnhofsnrZiel;
    }
    /**
     * Set bahnhofsnrZiel value
     * @param int $bahnhofsnrZiel
     * @return \StructType\BerechneEntfernungAnfrage
     */
    public function setBahnhofsnrZiel($bahnhofsnrZiel = null)
    {
        // validation for constraint: int
        if (!is_null($bahnhofsnrZiel) && !(is_int($bahnhofsnrZiel) || ctype_digit($bahnhofsnrZiel))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bahnhofsnrZiel, true), gettype($bahnhofsnrZiel)), __LINE__);
        }
        // validation for constraint: maxInclusive(9999999)
        if (!is_null($bahnhofsnrZiel) && $bahnhofsnrZiel > 9999999) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically less than or equal to 9999999', var_export($bahnhofsnrZiel, true)), __LINE__);
        }
        // validation for constraint: minInclusive(1000000)
        if (!is_null($bahnhofsnrZiel) && $bahnhofsnrZiel < 1000000) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must be numerically greater than or equal to 1000000', var_export($bahnhofsnrZiel, true)), __LINE__);
        }
        $this->bahnhofsnrZiel = $bahnhofsnrZiel;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BerechneEntfernungAnfrage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
